<!--- 
The contents of this file are subject to the Mozilla Public License Version 1.1
(the "License"); you may not use this file except in compliance with the
License. You may obtain a copy of the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is comprised of the PT Photo Gallery directory

The Initial Developer of the Original Code is
PaperThin, Inc. Copyright(C) 2016.
All Rights Reserved.

By downloading, modifying, distributing, using and/or accessing any files 
in this directory, you agree to the terms and conditions of the applicable 
end user license agreement.
--->

<!---
/* *************************************************************** */
Author: 	
	PaperThin, Inc.
	M. Carroll 
Custom Field Type:
	Photo Upload Link Field
Name:
	photo_upload_link_props.cfm
Summary:
	Custom select field to render an upload link to the photo element.
Version:
	4.0
History:
	2009-08-04 - MFC - Created
	2012-04-27 - MFC - Added option into the Photo Upload CFT to directly upload
						a photo or display the full photo form to the user.
	2012-07-05 - MFC - Added option to set the field value to store.
						Added field validation and security.
	2012-07-05 - MFC - Added options to enter the "Photo ID" and "Photo Upload" field names.
	2016-02-26 - DRM - Resource detection exit
--->

<!--- if this module loads resources, do it here.. --->
<!---<cfscript>
	// none
</cfscript>--->

<!--- ... then exit if all we're doing is detecting required resources --->
<cfif Request.RenderState.RenderMode EQ "getResources">
  <cfexit>
</cfif>


<cfscript>
	// initialize some of the attributes variables
	typeid = attributes.typeid;
	prefix = attributes.prefix;
	formname = attributes.formname;
	currentValues = attributes.currentValues;
	
	if( not structKeyExists(currentValues, "photoFieldID") )
		currentValues.photoFieldID = "";
	if( not structKeyExists(currentValues, "photoFormRender") )
		currentValues.photoFormRender = "form";
	if( not structKeyExists(currentValues, "photoCategoryID") )
		currentValues.photoCategoryID = "";
	if( not structKeyExists(currentValues, "photoFieldStore") )
		currentValues.photoFieldStore = "photoID";
	if( not structKeyExists(currentValues, "photoUploadNameField") )
		currentValues.photoUploadNameField = "photo";
	if( not structKeyExists(currentValues, "photoIDNameField") )
		currentValues.photoIDNameField = "photoID";
		
	// Get the element fields for the photo CE
	elementFldQry = application.ptPhotoGallery.ceData.getElementFieldsByFormID(formid=application.ptPhotoGallery.getPhotoFormID());
</cfscript>

<cfoutput>
	
	<script language="JavaScript" type="text/javascript">
		// register the fields with global props object
		fieldProperties['#typeid#'].paramFields = '#prefix#photoFieldID,#prefix#photoFormRender,#prefix#photoCategoryID,#prefix#photoFieldStore,#prefix#photoUploadNameField,#prefix#photoIDNameField';
		// allows this field to support the orange icon (copy down to label from field name)
		fieldProperties['#typeid#'].jsLabelUpdater = '#prefix#doLabel';
		// allows this field to have a common onSubmit Validator
		//fieldProperties['#typeid#'].jsValidator = '#prefix#doValidate';
		// handling the copy label function
		function #prefix#doLabel(str)
		{
			document.#formname#.#prefix#label.value = str;
		}
	/*	function #prefix#doValidate()
		{
			//set the default msgvalue
			document.#formname#.#prefix#msg.value = 'Please enter some text to be converted';
			if( document.#formname#.#prefix#foo.value.length == 0 )
			{
				alert('please Enter some data for foo');
				return false;
			}
			return true;
		}
	*/
	</script>
	<table width="550px;">
		<tr valign="top">
			<td class="cs_dlgLabelSmall" width="30%">Render Options:</td>
			<td class="cs_dlgLabelSmall" width="70%">
				<table>
					<tr valign="top">
						<td>
							<input type="radio" id="#prefix#photoFormRender" name="#prefix#photoFormRender" value="form" <cfif currentValues.photoFormRender EQ "form">checked="checked"</cfif>>			
						</td>
						<td>
							Full Photo Form<br />
							This option will display the full photo form to enter the photo name, abstract, category select, and upload form.
						</td>
					</tr>
					<tr valign="top">
						<td>
							<input type="radio" id="#prefix#photoFormRender" name="#prefix#photoFormRender" value="upload" <cfif currentValues.photoFormRender EQ "upload">checked="checked"</cfif>>		
						</td>
						<td>
							Upload Dialog<br />
							This option will open only the photo upload dialog and set the category to the selected default category field below.
						</td>
					</tr>
				</table>
				<br />
			</td>
		</tr>
		<tr valign="top">
			<td class="cs_dlgLabelSmall">Default Category:</td>
			<td class="cs_dlgLabelSmall">
				<!--- Get all the photo Categories --->
				<cfset photoCatData = application.ptPhotoGallery.photoDAO.getCategories()>
				<select name="#prefix#photoCategoryID" id="#prefix#photoCategoryID">
					<!--- Loop over the categories --->
					<cfloop index="i" from="1" to="#ArrayLen(photoCatData)#">
						<option value="#photoCatData[i].Values.categoryID#" <cfif currentValues.photoCategoryID EQ photoCatData[i].Values.categoryID>selected</cfif>>#photoCatData[i].Values.title#
					</cfloop>
				</select>
				<br />
				Select the photo category for the photo crop size requirements.
				<br /><br />
			</td>
		</tr>
		<tr valign="top">
			<td colspan="2">&nbsp;</td>
		</tr>
		<tr valign="top">
			<td class="cs_dlgLabelSmall">Photo Field to Store:</td>
			<td class="cs_dlgLabelSmall">
				<input type="radio" id="#prefix#photoFieldStore" name="#prefix#photoFieldStore" value="photoID" <cfif currentValues.photoFieldStore EQ 'photoID'>checked="checked"</cfif>>Photo ID<br />
				<input type="radio" id="#prefix#photoFieldStore" name="#prefix#photoFieldStore" value="photoURL" <cfif currentValues.photoFieldStore EQ 'photoURL'>checked="checked"</cfif>>Photo URL<br />
				Select the photo field value to store as the value when the photo upload is completed.<br /><br /> 
			</td>
		</tr>
		<tr valign="top">
			<td class="cs_dlgLabelSmall">Photo ID Field Name:</td>
			<td class="cs_dlgLabelSmall">
				<!--- <input type="text" id="#prefix#photoIDNameField" name="#prefix#photoIDNameField" value="#currentValues.photoIDNameField#" size="50"><br /> --->
				<!--- Loop over the fields --->
				<select id="#prefix#photoIDNameField" name="#prefix#photoIDNameField">
					<cfloop query="elementFldQry">
						<cfset currFieldName = Replace(elementFldQry.FieldName, "FIC_", "")>
						<option value="#currFieldName#" <cfif currFieldName EQ currentValues.photoIDNameField>selected='selected'</cfif>>#currFieldName#</option>
					</cfloop>
				</select><br />
				Custom element field name for the Photo ID field.
			</td>
		</tr>
		<tr valign="top">
			<td class="cs_dlgLabelSmall">Photo Upload Field Name:</td>
			<td class="cs_dlgLabelSmall">
				<!--- <input type="text" id="#prefix#photoUploadNameField" name="#prefix#photoUploadNameField" value="#currentValues.photoUploadNameField#" size="50"><br /> --->
				<!--- Loop over the fields --->
				<select id="#prefix#photoUploadNameField" name="#prefix#photoUploadNameField">
					<cfloop query="elementFldQry">
						<cfset currFieldName = Replace(elementFldQry.FieldName, "FIC_", "")>
						<option value="#currFieldName#" <cfif currFieldName EQ currentValues.photoUploadNameField>selected='selected'</cfif>>#currFieldName#</option>
					</cfloop>
				</select><br />
				Custom element field name for the Photo Upload field.
			</td>
		</tr>
		<tr valign="top">
			<td colspan="2">&nbsp;</td>
		</tr>
		<tr valign="top">
			<td class="cs_dlgLabelSmall">Photo Field ID:</td>
			<td class="cs_dlgLabelSmall">
				<input type="text" id="#prefix#photoFieldID" name="#prefix#photoFieldID" value="#currentValues.photoFieldID#" size="50"><br />
				JavaScript field ID for the Photo field within the form.
			</td>
		</tr>
	</table>
</cfoutput>